#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3100eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 3100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight31004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight31004xi = {
                1:'-1006x-2002y-2141z',
                2:'-1019x-2917y-247z',
                3:'-1047x-383y-2892z',
                4:'-1052x-933y-2762z',
                5:'-1093x-337y-2881z',
                6:'-1119x-2261y-1800z',
                7:'-1120x-1965y-2119z',
                8:'-1121x-894y-2748z',
                9:'-1137x-286y-2869z',
                10:'-116x-1033y-3026z',
                11:'-1171x-2862y-216z',
                12:'-1178x-231y-2857z',
                13:'-1188x-850y-2733z',
                14:'-1217x-174y-2845z',
                15:'-122x-535y-3051z',
                16:'-1233x-1921y-2096z',
                17:'-1245x-2214y-1775z',
                18:'-1253x-112y-2833z',
                19:'-1254x-801y-2719z',
                20:'-1318x-748y-2704z',
                21:'-1320x-2798y-185z',
                22:'-1344x-1871y-2073z',
                23:'-1369x-2161y-1750z',
                24:'-1379x-690y-2688z',
                25:'-1438x-627y-2673z',
                26:'-1453x-1814y-2050z',
                27:'-1465x-2727y-154z',
                28:'-1490x-2101y-1724z',
                29:'-1494x-561y-2657z',
                30:'-1547x-490y-2641z',
                31:'-1560x-1751y-2027z',
                32:'-158x-557y-3045z',
                33:'-1596x-415y-2624z',
                34:'-1607x-2647y-123z',
                35:'-1609x-2033y-1698z',
                36:'-1663x-1681y-2003z',
                37:'-169x-1022y-2921z',
                38:'-1724x-1959y-1672z',
                39:'-1744x-2561y-92z',
                40:'-1764x-1605y-1979z',
                41:'-1836x-1878y-1646z',
                42:'-1861x-1523y-1956z',
                43:'-1876x-2466y-61z',
                44:'-1943x-1790y-1619z',
                45:'-1953x-1435y-1931z',
                46:'-197x-577y-3039z',
                47:'-2003x-2365y-30z',
                48:'-2042x-1341y-1907z',
                49:'-2047x-1696y-1593z',
                50:'-207x-2075y-2293z',
                51:'-2124x-2257y0z',
                52:'-2126x-1242y-1882z',
                53:'-2146x-1596y-1566z',
                54:'-2204x-1138y-1858z',
                55:'-222x-2380y-1972z',
                56:'-2239x-1490y-1539z',
                57:'-2278x-1028y-1833z',
                58:'-228x-3065y-401z',
                59:'-229x-1040y-2911z',
                60:'-2327x-1379y-1512z',
                61:'-2345x-914y-1808z',
                62:'-238x-594y-3033z',
                63:'-2407x-796y-1783z',
                64:'-2410x-1262y-1485z',
                65:'-2463x-673y-1757z',
                66:'-2486x-1140y-1458z',
                67:'-2512x-547y-1731z',
                68:'-2554x-418y-1706z',
                69:'-2555x-1014y-1431z',
                70:'-2589x-285y-1680z',
                71:'-2618x-883y-1403z',
                72:'-2674x-749y-1375z',
                73:'-2723x-611y-1347z',
                74:'-281x-608y-3026z',
                75:'-291x-1055y-2900z',
                76:'-30x-456y-3066z',
                77:'-318x-2084y-2272z',
                78:'-327x-619y-3019z',
                79:'-350x-2385y-1948z',
                80:'-355x-1066y-2889z',
                81:'-374x-627y-3012z',
                82:'-388x-3053y-370z',
                83:'-420x-1072y-2877z',
                84:'-424x-631y-3005z',
                85:'-432x-2086y-2251z',
                86:'-474x-632y-2997z',
                87:'-478x-2382y-1924z',
                88:'-488x-1075y-2866z',
                89:'-526x-630y-2989z',
                90:'-546x-2083y-2229z',
                91:'-548x-3032y-339z',
                92:'-557x-1073y-2854z',
                93:'-578x-623y-2980z',
                94:'-58x-484y-3061z',
                95:'-607x-2372y-1900z',
                96:'-627x-1067y-2841z',
                97:'-631x-613y-2972z',
                98:'-661x-2072y-2208z',
                99:'-67x-3068y-432z',
                100:'-685x-598y-2963z',
                101:'-697x-1057y-2829z',
                102:'-6x-426y-3070z',
                103:'-707x-3002y-309z',
                104:'-736x-2355y-1875z',
                105:'-739x-580y-2954z',
                106:'-768x-1041y-2816z',
                107:'-776x-2055y-2186z',
                108:'-792x-557y-2944z',
                109:'-840x-1022y-2803z',
                110:'-845x-531y-2934z',
                111:'-864x-2331y-1850z',
                112:'-864x-2964y-278z',
                113:'-88x-510y-3056z',
                114:'-892x-2032y-2164z',
                115:'-897x-500y-2924z',
                116:'-911x-997y-2790z',
                117:'-949x-465y-2914z',
                118:'-97x-2060y-2314z',
                119:'-97x-2369y-1996z',
                120:'-982x-967y-2776z',
                121:'-992x-2299y-1825z',
                122:'-998x-426y-2903z'}

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3100eight4xi" usage = "target function for charge3100eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3100eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3100EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3100EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3100EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3100EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3100EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight31004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3100EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3100EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3100EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight31004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight31004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3100EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3100EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3100EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3100eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  